
import ctypes
import os

from .hdl_services import HdlServices

# class s_vpi_vlog_info(ctypes.Structure):
#     _fields_ = [
#         ('argc', ctypes.c_int32),
#         ('argv', ctypes.POINTER(ctypes.c_char_p)),
#         ('product', ctypes.c_char_p),
#         ('version', ctypes.c_char_p)
#     ]


# print("hdl_if.init", flush=True)

# def init():
#     print("::init", flush=True)

# try:
#     exe = ctypes.cdll.LoadLibrary(None)

#     exe.vpi_get_vlog_info.restype = ctypes.c_int
#     exe.vpi_get_vlog_info.argtypes = [
#         ctypes.POINTER(s_vpi_vlog_info)
#     ]

#     info = s_vpi_vlog_info()
#     exe.vpi_get_vlog_info(ctypes.pointer(info))

#     print("argc: %d" % info.argc)

# except Exception as e:
#     print("Exception: %s" % str(e))

def vpi_init():
    import hdl_pi_if.vpi as vpi
    print("::vpi_init")
    vpi.vpi_init()

def dpi_init(scope):
    import hdl_pi_if.dpi as dpi
    print("::dpi_init")

    dpi.dpi_init(scope)

def get_none():
    return None

def get_entry():
    hdl_pi_if_dir = os.path.dirname(os.path.abspath(__file__))

    for f in os.listdir(hdl_pi_if_dir):
        if f.endswith(".so") and f.startswith("entry"):
            return os.path.join(hdl_pi_if_dir, f)
    
    raise Exception("Failed to find entry .so")

def mkTask(coro):
    from .backend import Backend
    be = Backend.inst()
    print("-- mkTask", flush=True)
    task = be.mkTask(coro)

    be.idle()

    return task


